class Tree {
  TreeNode root;
  int totalLevels;

  Tree(int x, int y, int numLevels) {
    totalLevels = numLevels;
    root = makeTree(x, y, numLevels);
  }

  String preOrder(TreeNode curr) {
    if(curr == null) { return "";}
    return curr.data + preOrder(curr.left) + preOrder(curr.right);
  }

  String inOrder(TreeNode curr) {
    if(curr == null) { return "";}
    return inOrder(curr.left) + curr.data + inOrder(curr.right);
  }

  String postOrder(TreeNode curr) {
    if(curr == null) { return "";}
    return postOrder(curr.left) + postOrder(curr.right) + curr.data;
  }

  TreeNode makeTree(int x, int y, int nl) {
    if (nl <= 0) return null; //base case

    float xoff = width / (pow(2, totalLevels - nl+2)); //width / 2^(depth+1)
    int yoff = 50;
    TreeNode currRoot = new TreeNode(x, y);
    currRoot.left = makeTree(int(x - xoff), y+yoff, nl-1);
    currRoot.right = makeTree(int(x + xoff), y+yoff, nl-1);
    return currRoot;
  }

  void display() { display(root); } // if called with no args, display from root
  void display(TreeNode curr) {
    if (curr == null) {
      return;
    }
    curr.display();
    display(curr.left);
    display(curr.right);
  }
}
